package com.qmth.sop.business.service.impl;

import com.qmth.sop.business.entity.SysUser;
import com.qmth.sop.business.service.SsoService;
import com.qmth.sop.business.service.SysConfigService;
import com.qmth.sop.business.sync.RtzfApiUtils;
import com.qmth.sop.business.sync.been.rtzf.LoginTypeEnum;
import com.qmth.sop.common.contant.SystemConstant;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.StringJoiner;

/**
 * @Description: sso单点登录服务实现类
 * @Author: CaoZixuan
 * @Date: 2023-11-22
 */
@Service
public class SsoServiceImpl implements SsoService {
    @Resource
    private RtzfApiUtils rtzfApiUtils;
    @Resource
    private SysConfigService sysConfigService;

    @Override
    public String rtzfSsoLogin(SysUser requestUser) {
        String ssoUrl = sysConfigService.findByConfigKey(SystemConstant.RTZF_OSS_LOGIN_URL).getConfigValue();
        String token = rtzfApiUtils.getRtzfToken(requestUser, LoginTypeEnum.SSO_LOGIN);

        StringJoiner redirectUrlJoiner = new StringJoiner("");
        redirectUrlJoiner.add(ssoUrl);
        redirectUrlJoiner.add(SystemConstant.GET_UNKNOWN).add(SystemConstant.SIGNATURE).add(SystemConstant.GET_EQUAL).add(token);
        return redirectUrlJoiner.toString();
    }
}
